/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.VersionSystem;

@Lazy
@Repository
public interface VersionSystemDao extends CrudRepository<VersionSystem, Integer> {

	

	@Query("select distinct model from VersionSystem model")
	List<VersionSystem> findAllList(Pageable page);

	@Query("select distinct model from VersionSystem model where model.namaVersion like %:namaVersion% "
			+ "or (model.kdVersion in (select model2.kdVersionHead from VersionSystem model2 where model2.namaVersion like %:namaVersion% )) "
			+ "or (model.kdVersionHead in (select model2.kdVersion from VersionSystem model2 where model2.namaVersion like %:namaVersion% ))")
	List<VersionSystem> findAllList(@Param("namaVersion")String namaVersion, Pageable page);

	@Query("select  model from VersionSystem model where model.kdVersion=:kdVersion "
			+ "or (model.kdVersion in (select model2.kdVersionHead from VersionSystem model2 where model2.kdVersion=:kdVersion ))"
			+ "or (model.kdVersionHead in (select model2.kdVersion from VersionSystem model2 where model2.kdVersion=:kdVersion )) ")
	List<VersionSystem> findByKdVersionSystemWithIsHierarkiTrue(@Param("kdVersion") Integer kdVersion);
	
	@Query("select model from VersionSystem model where model.kdVersion=:kdVersion ")
	List<VersionSystem> findByKdVersionSystemWithIsHierarkiFalse(@Param("kdVersion") Integer kdVersion);

	@Query("select new map(model.kdVersion as kdVersion "
			+ ", model.namaVersion as namaVersion,model.kdVersionHead as kdVersionHead) from VersionSystem model where model.kdVersionHead=:kdVersion and  model.statusEnabled = true  ")
	List<Map<String, Object>> findVersionSystemByHead(@Param("kdVersion") Integer kdVersion);


	@Query("select distinct model from VersionSystem model where model.statusEnabled=true")
	List<VersionSystem> findAllListCombo(Pageable page);

	@Query("select distinct model from VersionSystem model where model.namaVersion like %:namaVersion% and model.statusEnabled=true "
			+ "or (model.kdVersion in (select model2.kdVersionHead from VersionSystem model2 where model2.namaVersion like %:namaVersion% and model2.statusEnabled=true)) "
			+ "or (model.kdVersionHead in (select model2.kdVersion from VersionSystem model2 where model2.namaVersion like %:namaVersion% and model2.statusEnabled=true))")
	List<VersionSystem> findAllListCombo(@Param("namaVersion")String namaVersion, Pageable page);

	

}
